//+------------------------------------------------------------------+
//|                                                            a.mq4 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

#include "dummy_set_features.mqh"

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
    int handle=FileOpen("dummy_set_features.csv",FILE_READ|FILE_CSV|FILE_ANSI,",");
    if(handle!=INVALID_HANDLE) {
      string tst;
      double inp[NVARS], output[NCLASS];
      int i, result, line=0, error=0;
      for(i=0;i<=ArraySize(inp);i++) tst=FileReadString(handle);      //skip header
      line++;
      while(!FileIsEnding(handle)) {
        for(i=0;i<=ArraySize(inp);i++) {
          tst=FileReadString(handle);
          if(i<ArraySize(inp)) inp[i]=StringToDouble(tst);            //read variable 
          else result=(int)StringToInteger(tst);                      //read result
        }
        RandomDecisionForest(inp,output);                             //process func
        if(output[result]!=1.0) {                                     //class != 100%
          error++;                                                    //error counter
          PrintFormat("Error# %d at Line# %d",error,line);
        }
        line++;
      }
      FileClose(handle);
      PrintFormat("Total Lines=%d. Total Errors=%d.",line,error);
    } else Print("FileOpen dummy_set_features.csv Error!");  
  }
